#! /usr/bin/python -Es
# Copyright (C) 2011 Red Hat 
# see file 'COPYING' for use and warranty information
#
# setrans is a tool for analyzing process transistions in SELinux policy
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation; either version 2 of
#    the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA     
#                                        02111-1307  USA
#
#  
import sepolicy, sys
search=sepolicy.search
info=sepolicy.info
_failedlist = []
__all__ = [ 'setrans', ]

def _entrypoint(src):
    trans=search([sepolicy.ALLOW],{sepolicy.SOURCE:src})
    return map(lambda y: y[sepolicy.TARGET], filter(lambda x: "entrypoint" in x[sepolicy.PERMS], trans))
    

def _get_trans(src, dest, slist, tlist = []):
    foundstr = ""
    trans=search([sepolicy.ALLOW],{sepolicy.SOURCE:src})
    targets = map(lambda y: y[sepolicy.TARGET], filter(lambda x: "transition" in x[sepolicy.PERMS], trans))

    _failedlist.append(src)
    if src in tlist:
        return False

    for f in _failedlist:
        if f in targets:
            targets.remove(f)

    if len(targets) == 0:
        return False

    tlist.append(src)
    
    if not dest:
        for t in targets:
            if len(_entrypoint(t)):
                slist.append((src, _entrypoint(t)[0], t))
        return True

    if dest in targets:
        slist.append(tlist + [ dest ])
        return True

    for t in targets:
        _get_trans(t,dest, slist, tlist)
        if t in tlist:
            tlist.remove(t)

    return True

def setrans(source, dest = None):
    slist=[]
    _get_trans(source, dest, slist)
    return slist
